package Tetris;

import java.awt.Color;
import java.awt.GridLayout;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.util.ArrayList;
import java.util.Iterator;

import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;

public class MainFrame extends JFrame
{
	Block block = new Block();
	Score ScorePanel = new Score();
	
	int gameX = 20;//Game X-length
	int gameY = 30;//Game Y-length
	JPanel GamePanel = new JPanel();
	JLabel[][] GL = new JLabel[gameY][gameX];
	int[][] GameArray = new int[gameY][gameX];
	int[][] StandardArray = new int[gameY][gameX];
	Down down = new Down();
	ArrayList<Integer> line = new ArrayList<Integer>();
	
	void test()
	{
//		for(int i = 0; i < gameY; i++)//check array
//		{
//			for(int j = 0; j < gameX; j++)
//				System.out.print(GameArray[i][j] + " ");
//			System.out.println();
//		}
//		System.out.println("\n\n\n\n\n\n\n");
	}
	
	ArrayList<Integer> LineCheck()//full line check
	{
		ArrayList<Integer> Item = new ArrayList<Integer>();
		int count;
		for(int i = 0; i < gameY; i++)
		{
			count = 0;
			
			for(int j = 0; j < gameX; j++)
				if(GameArray[i][j] == 1) 
					count++;

			if(count == gameX) Item.add(i);
		}
		
		return Item;
	}
	
	void LineRemove()//full line remove
	{
		line = LineCheck();
		Iterator<Integer> iter = line.iterator();
		int index = 0;
		int size = line.size();
		ScorePanel.Scoring(size);
		while(iter.hasNext())
		{
			index = iter.next();
			for(int i = index; i > 1; i--)
				for(int j = 0; j < gameX; j++)
					GameArray[i][j] = GameArray[i-1][j];
			
		}
		index = 0;	 
	}
	
	boolean Overlap()//overlap
	{
		try
		{
			for(int i = 0; i < block.array_size; i++)
				for(int j = 0; j < block.array_size; j++)
					if(block.array[i][j] == 1 && 
					StandardArray[i+block.y][j+block.x] == 1)//block overlap
						throw new Exception();
			return false;
		}
		catch(Exception e)
		{
			return true;
		}
		
	}
	
	void Next()//next block
	{
		for(int i = 0; i < gameY; i++)//Game repaint
			for(int j = 0; j < gameX; j++)
				StandardArray[i][j] = GameArray[i][j];
		block = ScorePanel.Pre_block;//next block
		ScorePanel.Pre_block = new Block();
	}
	
	void View()//view
	{
		for(int i = 0; i < gameY; i++)
			for(int j = 0; j < gameX; j++)//Game repaint
			{
				GameArray[i][j] = StandardArray[i][j];
				
				if(GameArray[i][j] == 0)
					GL[i][j].setBackground(null);
			}
		
		for(int i = 0; i < block.array_size; i++)
			for(int j = 0; j < block.array_size; j++)//Block repaint
				if(block.array[i][j] == 1)
				{
					GameArray[i+block.y][j+block.x] = 1;
					GL[i+block.y][j+block.x].setBackground(block.color);
					GL[i+block.y][j+block.x].setOpaque(true);
				}
	}

	class Down extends Thread//down
	{
		@Override
		public void run() 
		{
			// TODO Auto-generated method stub
			super.run();
				
			try 
			{
				while(true)
				{
					
					block.y++;
					if(block.y > 26 || Overlap())//bottom
						throw new Exception();
					View();
					test();
					sleep(3000);
				}
				
			} 
			catch (InterruptedException e)
			{
				// TODO Auto-generated catch block
				System.out.println("End");
				e.printStackTrace();
			}
			catch (Exception e)//bottom
			{
				LineRemove();
				Next();
				run();
				return;
			}
		}
	}
	
	class Keyboard implements KeyListener//keyboard
	{

		@Override
		public void keyTyped(KeyEvent e) {
			// TODO Auto-generated method stub
			
		}

		@Override
		public void keyPressed(KeyEvent e) 
		{
			// TODO Auto-generated method stub
			try
			{
				switch(e.getKeyCode())
				{
				case 37://←
					if(Overlap()) break;
					block.x--;
					test();
					View();
					break;
				case 38://↑
					block.Rotate();
					test();
					View();
					break;
				case 39://→
					if(Overlap()) break;
					block.x++;
					test();
					View();
					break;
				case 40://↓
					if(Overlap()) break;
					block.y++;
					test();
					View();
				}
			}
			catch(ArrayIndexOutOfBoundsException a)
			{
				switch(e.getKeyCode())
				{
				case 37://←
					block.x++;
					test();
					View();
					break;
				case 39://→
					block.x--;
					test();
					View();
					break;
				case 40://↓
					block.y--;
					test();
					View();
				}
			}
		}

		@Override
		public void keyReleased(KeyEvent e) {
			// TODO Auto-generated method stub	
			
		}	
	}
	
	MainFrame() //main
	{
		// TODO Auto-generated constructor stub
		setTitle("TETRIS");
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		setLayout(null);
		
		ScorePanel.setBounds(240, 20, 90, 300);
		GamePanel.setBounds(20, 20, 200, 300);
		GamePanel.setLayout(new GridLayout(30, 20, 1, 1));
		GamePanel.setBackground(Color.lightGray);
		GamePanel.setOpaque(true);
		
		for(int i = 0; i < gameY; i++)
			for(int j = 0; j < gameX; j++)//Game initialize
			{
				GL[i][j] = new JLabel();
				GamePanel.add(GL[i][j]);
			}
				
		//////test(Bottom OBlock)//////
//		for(int i = gameY-2; i < gameY; i++)
//			for(int j = 2; j < gameX; j++)
//			{
//				StandardArray[i][j] = 1;
//				GL[i][j].setBackground(block.color);
//				GL[i][j].setOpaque(true);
//			}		
//		View();
		///////////////////////////////
		down.start();
		
		add(GamePanel);
		add(ScorePanel);
		setSize(350, 400);
		setVisible(true);
		addKeyListener(new Keyboard());
		requestFocus();
	}
	
	public static void main(String[] args) 
	{
		// TODO Auto-generated method stub
		new MainFrame();
		
	}
}
//질문1 : 배열 이름으로 값을 한번에 대입하면 
